//---------------------------------------------------------------------------
#ifndef App_CommonH
#define App_CommonH
//---------------------------------------------------------------------------
#include <Classes.hpp>
namespace Inifiles {class TMemIniFile;} using namespace Inifiles;
//---------------------------------------------------------------------------
namespace App_common {
//---------------------------------------------------------------------------
class EAppError : public Exception
{
public:
	__fastcall EAppError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class TCommon
{
private:
protected:
public:
	static const AnsiString About;
	static const AnsiString HelpFile;
	static const AnsiString SettingsFile;
};
//---------------------------------------------------------------------------
class TSettingsHandler : public TObject
{
private:
protected:
public:
	__fastcall TSettingsHandler();
	virtual __fastcall ~TSettingsHandler();
	virtual void __fastcall LoadSettings(TMemIniFile* ASettings, const AnsiString& ASection);
	virtual void __fastcall SaveSettings(TMemIniFile* ASettings, const AnsiString& ASection);
};
//---------------------------------------------------------------------------
class TModel : public TSettingsHandler
{
private:
protected:
public:
	__fastcall TModel();
	virtual __fastcall ~TModel();
};
//---------------------------------------------------------------------------
class TSelection : public TSettingsHandler
{
private:
protected:
public:
	__fastcall TSelection();
	virtual __fastcall ~TSelection();
};
//---------------------------------------------------------------------------
class TCommands : public TSettingsHandler
{
private:
protected:
	virtual void __fastcall HandleFeatureUnavailable();
public:
	__fastcall TCommands();
	virtual __fastcall ~TCommands();
};
//---------------------------------------------------------------------------
class TSettingsHandlers : public TObject
{
private:
	TStrings* FList;
	__property TStrings* List = {read=FList};
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	TSettingsHandler* __fastcall GetItem(int AIndex);
	int __fastcall GetCount();
	int __fastcall GetCapacity();
	void __fastcall SetCapacity(int ACapacity);
protected:
public:
	__fastcall TSettingsHandlers();
	virtual __fastcall ~TSettingsHandlers();
	virtual void __fastcall Add(TSettingsHandler* AItem, const AnsiString& ASection);
	virtual void __fastcall Remove(TSettingsHandler* AItem);
	virtual void __fastcall Clear();
	virtual void __fastcall LoadSettings();
	virtual void __fastcall SaveSettings();
	__property TSettingsHandler* Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount};
	__property int Capacity = {read=GetCapacity, write=SetCapacity};
};
//---------------------------------------------------------------------------
} // End namespace App_common
using namespace App_common;
//---------------------------------------------------------------------------
#endif

