//---------------------------------------------------------------------------
#ifndef App_DoubleEntriesH
#define App_DoubleEntriesH
//---------------------------------------------------------------------------
#include "App_Double.h"
//---------------------------------------------------------------------------
namespace App_doubleentries {
//---------------------------------------------------------------------------
class TDoubleEntry : public TObject
{
private:
	AnsiString FPath;
	static AnsiString __fastcall EnsureValidPath(const AnsiString& APath);
protected:
public:
	__fastcall TDoubleEntry(const AnsiString& AFile);
	virtual __fastcall ~TDoubleEntry();
	__property AnsiString Path = {read=FPath};
};
//---------------------------------------------------------------------------
class TDoubleEntriesModel : public TModel
{
private:
	TObjectList* FList;
	TNotifyEvent FOnChange;
	static int __fastcall SortCompare(void* AItem1, void* AItem2);
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	TDoubleEntry* __fastcall GetItem(int AIndex);
	int __fastcall GetCount();
	int __fastcall GetCapacity();
	void __fastcall SetCapacity(int ACapacity);
	__property TObjectList* List = {read=FList};
protected:
	virtual void __fastcall DoChange();
public:
	__fastcall TDoubleEntriesModel();
	virtual __fastcall ~TDoubleEntriesModel();
	virtual void __fastcall AddItems(const DynamicArray<TDoubleEntry*>& AItems);
	virtual void __fastcall Clear();
	virtual void __fastcall Sort();
	__property TDoubleEntry* Items[int AIndex] = {read=GetItem};
	__property int Count = {read=GetCount};
	__property int Capacity = {read=GetCapacity, write=SetCapacity};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
} // End namespace App_doubleentries
using namespace App_doubleentries;
//---------------------------------------------------------------------------
#endif

