//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Clipbrd.hpp>
#include "App_ErrorDialog.h"
#include "Moa_AutoPointers.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TErrorDialog* ErrorDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Action1Execute(TObject* ASender)
{
	TAutoPointer<TStrings> LLines = new TStringList();
	LLines->Capacity = ListBox1->SelCount;
	for(int LI = 0; LI < ListBox1->Count; ++LI) {
		if(!ListBox1->Selected[LI]) {
			continue;
		}
		LLines->Add(ListBox1->Items->Strings[LI]);
		if(LLines->Count == ListBox1->SelCount) {
			break;
		}
	}
	Clipboard()->AsText = LLines->Text;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Action1Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = ListBox1->SelCount > 0;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Action2Execute(TObject* ASender)
{
	ListBox1->Items->BeginUpdate();
	try {
		ListBox1->SelectAll();
	}
	catch(...) {
		ListBox1->Items->EndUpdate();
		throw;
	}
	ListBox1->Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Action2Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Action3Execute(TObject* ASender)
{
	ListBox1->Items->BeginUpdate();
	try {
		for(int LI = 0; LI < ListBox1->Items->Count; ++LI) {
			ListBox1->Selected[LI] = !ListBox1->Selected[LI];
		}
	}
	catch(...) {
		ListBox1->Items->EndUpdate();
		throw;
	}
	ListBox1->Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Action3Update(TObject* ASender)
{
	TAction* LAction = static_cast<TAction*>(ASender);
	LAction->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::ActionList1Execute(TBasicAction* AAction, bool& AHandled)
{
	AHandled = false;
	TAction* LAction = static_cast<TAction*>(AAction);
	if(LAction->OnExecute == NULL) {
		return;
	}
	TCursor LCursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
	try {
		try {
			ActiveControl = ListBox1;
			LAction->OnExecute(LAction);
			AHandled = true;
		}
		catch(...) {
			UpdateAccess();
			throw;
		}
		UpdateAccess();
	}
	catch(...) {
		Screen->Cursor = LCursor;
		throw;
	}
	Screen->Cursor = LCursor;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::ActionList1Update(TBasicAction* AAction, bool& AHandled)
{
	AHandled = true;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::ListBox1Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::UpdateScrollWidth(TListBox* AListBox)
{
	int LScrollWidth = 0;
	for(int LI = 0; LI < AListBox->Items->Count; ++LI) {
		int LTextWidth = AListBox->Canvas->TextWidth(AListBox->Items->Strings[LI]);
		if(LTextWidth > LScrollWidth) {
			LScrollWidth = LTextWidth;
		}
	}
	AListBox->ScrollWidth = LScrollWidth;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::UpdateAccess()
{
	for(int LI = 0; LI < ActionList1->ActionCount; ++LI) {
		TAction* LAction = static_cast<TAction*>(ActionList1->Actions[LI]);
		if(LAction->OnUpdate != NULL) {
			LAction->OnUpdate(LAction);
		}
	}
}
//---------------------------------------------------------------------------
TStrings* __fastcall TErrorDialog::GetValues()
{
	return ListBox1->Items;
}
//---------------------------------------------------------------------------
__fastcall TErrorDialog::TErrorDialog(TComponent* AOwner) :
	TForm(AOwner)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TErrorDialog::~TErrorDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TErrorDialog* __fastcall TErrorDialog::EnsureCreated()
{
	if(ErrorDialog == NULL) {
		ErrorDialog = new TErrorDialog(Application);
	}
	return ErrorDialog;
}
//---------------------------------------------------------------------------
void __fastcall TErrorDialog::Execute()
{
	UpdateScrollWidth(ListBox1);
	if(ListBox1->Items->Count > 0) {
		ListBox1->ClearSelection();
		ListBox1->ItemIndex = 0;
		ListBox1->TopIndex = 0;
	}
	UpdateAccess();
	ActiveControl = NULL;
	SelectFirst();
	ShowModal();
}
//---------------------------------------------------------------------------

