//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_MenuDialog.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMenuDialog* MenuDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Value = Input;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::RadioButton1Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::RadioButton2Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::RadioButton3Click(TObject* ASender)
{
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::Initialize()
{
	try {
		Image1->Picture->Icon->Assign(Application->Icon);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::Uninitialize()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::HandleInvalidInput(const AnsiString& AMessage, TWinControl* AControl)
{
	ActiveControl = AControl;
	throw EAppError(AMessage);
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::HandleInvalidValue(const AnsiString& AMessage)
{
	throw EAppError(AMessage);
}
//---------------------------------------------------------------------------
TMenuResult __fastcall TMenuDialog::GetInput()
{
	TMenuResult LInput = mnOptions;
	if(RadioButton1->Checked) {
		LInput = mnOptions;
	}
	else if(RadioButton2->Checked) {
		LInput = mnHelp;
	}
	else if(RadioButton3->Checked) {
		LInput = mnAbout;
	}
	else {
		HandleInvalidInput("Choose an item.", RadioButton1);
	}
	return LInput; 
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::SetInput(TMenuResult AInput)
{
	TRadioButton* LRadioButton = NULL;
	switch(AInput) {
	case mnOptions:
		LRadioButton = RadioButton1;
		break;
	case mnHelp:
		LRadioButton = RadioButton2;
		break;
	case mnAbout:
		LRadioButton = RadioButton3;
		break;
	default:
		HandleInvalidValue("The program does not support the result.");
		break;
	}
	LRadioButton->Checked = true;
	ActiveControl = LRadioButton;
	UpdateAccess();
}
//---------------------------------------------------------------------------
void __fastcall TMenuDialog::UpdateAccess()
{
	Button1->Enabled =
		RadioButton1->Checked ||
		RadioButton2->Checked ||
		RadioButton3->Checked;
}
//---------------------------------------------------------------------------
__fastcall TMenuDialog::TMenuDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValue(mnOptions)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TMenuDialog::~TMenuDialog()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
TMenuDialog* __fastcall TMenuDialog::EnsureCreated()
{
	if(MenuDialog == NULL) {
		MenuDialog = new TMenuDialog(Application);
	}
	return MenuDialog;
}
//---------------------------------------------------------------------------
bool __fastcall TMenuDialog::Execute()
{
	Input = Value;
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

