//----------------------------------------------------------------------------
#ifndef App_MenuDialogH
#define App_MenuDialogH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include "App_Common.h"
//---------------------------------------------------------------------------
namespace App_menudialog {
//---------------------------------------------------------------------------
enum TMenuResult
{
	mnOptions,
	mnHelp,
	mnAbout,
};
//---------------------------------------------------------------------------
} // End namespace App_menudialog
using namespace App_menudialog;
//---------------------------------------------------------------------------
class TMenuDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TImage* Image1;
	TLabel* Label1;
	TRadioButton* RadioButton1;
	TRadioButton* RadioButton2;
	TRadioButton* RadioButton3;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall RadioButton1Click(TObject* ASender);
	void __fastcall RadioButton2Click(TObject* ASender);
	void __fastcall RadioButton3Click(TObject* ASender);
private:
	TMenuResult FValue;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandleInvalidInput(const AnsiString& AMessage, TWinControl* AControl);
	void __fastcall HandleInvalidValue(const AnsiString& AMessage);
	void __fastcall UpdateAccess();
	TMenuResult __fastcall GetInput();
	void __fastcall SetInput(TMenuResult AInput);
	__property TMenuResult Input = {read=GetInput, write=SetInput};
protected:
public:
	__fastcall TMenuDialog(TComponent* AOwner);
	virtual __fastcall ~TMenuDialog();
	static TMenuDialog* __fastcall EnsureCreated();
	virtual bool __fastcall Execute();
	__property TMenuResult Value = {read=FValue, write=FValue};
};
//----------------------------------------------------------------------------
extern PACKAGE TMenuDialog* MenuDialog;
//----------------------------------------------------------------------------
#endif

