//---------------------------------------------------------------------------
#ifndef App_OpenH
#define App_OpenH
//---------------------------------------------------------------------------
#include "App_Documents.h"
#include "App_Programs.h"
//---------------------------------------------------------------------------
namespace App_open {
//---------------------------------------------------------------------------
class TOpenTask;
class TOpenCommands : public TCommands
{
private:
	TProgramEntriesModel* FProgramEntriesModel;
	TProgramEntriesSelection* FProgramEntriesSelection;
	TDocumentEntriesModel* FDocumentEntriesModel;
	TOpenTask* FTask;
	void __fastcall TaskTerminate(TObject* ASender);
	void __fastcall TaskProgress(TObject* ASender, int ACurrent, int AAll);
	void __fastcall TaskNext(TObject* ASender, TProgramEntry* AProgramEntry, TDocumentEntry* ADocumentEntry);
	void __fastcall TaskPrepare(TObject* ASender);
	void __fastcall TaskOpen(TObject* ASender);
	void __fastcall TaskOpenFail(TObject* ASender);
	void __fastcall TaskWait(TObject* ASender);
	void __fastcall TaskWaitFail(TObject* ASender);
	void __fastcall TaskNoWait(TObject* ASender);
	void __fastcall TaskUnprepare(TObject* ASender);
	void __fastcall TaskInformation(TObject* ASender, const AnsiString& AMessage);
	void __fastcall TaskWarning(TObject* ASender, const AnsiString& AMessage);
	void __fastcall TaskError(TObject* ASender, const AnsiString& AMessage);

	void __fastcall ProgressDialogContinue(TObject* ASender);
	void __fastcall ProgressDialogCancel(TObject* ASender);
	__property TProgramEntriesModel* ProgramEntriesModel = {read=FProgramEntriesModel};
	__property TProgramEntriesSelection* ProgramEntriesSelection = {read=FProgramEntriesSelection};
	__property TDocumentEntriesModel* DocumentEntriesModel = {read=FDocumentEntriesModel};
	__property TOpenTask* Task = {read=FTask};
protected:
public:
	__fastcall TOpenCommands(
		TProgramEntriesModel* AProgramEntriesModel, 
		TProgramEntriesSelection* AProgramEntriesSelection, 
		TDocumentEntriesModel* ADocumentEntriesModel);
	virtual __fastcall ~TOpenCommands();
	virtual void __fastcall Start();
	virtual bool __fastcall CanStart();
};
//---------------------------------------------------------------------------
} // End namespace App_open
using namespace App_open;
//---------------------------------------------------------------------------
#endif

