//---------------------------------------------------------------------------
#ifndef App_ProcessesH
#define App_ProcessesH
//---------------------------------------------------------------------------
#include "App_Common.h"
//---------------------------------------------------------------------------
namespace App_processes {
//---------------------------------------------------------------------------
class EProcessError : public EAppError
{
public:
	__fastcall EProcessError(const AnsiString& AMessage) : EAppError(AMessage) {}
};
//---------------------------------------------------------------------------
class EProcessCreateError : public EProcessError
{
public:
	__fastcall EProcessCreateError(const AnsiString& AMessage) : EProcessError(AMessage) {}
};
//---------------------------------------------------------------------------
class EProcessUnavailable : public EProcessError
{
public:
	__fastcall EProcessUnavailable(const AnsiString& AMessage) : EProcessError(AMessage) {}
};
//---------------------------------------------------------------------------
class EProcessWaitFail : public EProcessError
{
public:
	__fastcall EProcessWaitFail(const AnsiString& AMessage) : EProcessError(AMessage) {}
};
//---------------------------------------------------------------------------
class TProcess;
class TProcessCreator : public TObject
{
private:
	AnsiString FFile;
	AnsiString FParameters;
	AnsiString FWorkingDirectory;
	int FShowCommand;
	bool FReturnProcess;
protected:
public:
	__fastcall TProcessCreator();
	virtual __fastcall ~TProcessCreator();
	virtual TProcess* __fastcall Execute();
	__property AnsiString File = {read=FFile, write=FFile};
	__property AnsiString Parameters = {read=FParameters, write=FParameters};
	__property AnsiString WorkingDirectory = {read=FWorkingDirectory, write=FWorkingDirectory};
	__property int ShowCommand = {read=FShowCommand, write=FShowCommand};
	__property bool ReturnProcess = {read=FReturnProcess, write=FReturnProcess};
};
//---------------------------------------------------------------------------
class TProcess : public TObject
{
private:
	HANDLE FHandle;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
protected:
public:
	__fastcall TProcess(HANDLE AHandle);
	virtual __fastcall ~TProcess();
	virtual bool __fastcall IsTerminated(int ATimeoutInterval = -1);
	__property HANDLE Handle = {read=FHandle};
};
//---------------------------------------------------------------------------
} // End namespace App_processes
using namespace App_processes;
//---------------------------------------------------------------------------
#endif

