//---------------------------------------------------------------------------
#ifndef App_ProgressDialogH
#define App_ProgressDialogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <StdCtrls.hpp>
#include "App_Common.h"
//---------------------------------------------------------------------------
class TProgressDialog : public TForm
{
__published:
	TButton* CancelButton;
	TButton* ContinueButton;
	TImage *InformationImage;
	TImage *WarningImage;
	TImage *ErrorImage;
	TLabel* DocumentLabel;
	TLabel* Label1;
	TLabel* Label2;
	TLabel* MessageLabel;
	TLabel* ProgramLabel;
	TProgressBar* ProgressBar;
	void __fastcall FormCloseQuery(TObject* ASender, bool& ACanClose);
	void __fastcall ContinueButtonClick(TObject* ASender);
private:
	TNotifyEvent FOnContinue;
	TNotifyEvent FOnCancel;
protected:
	virtual void __fastcall DoContinue();
	virtual void __fastcall DoCancel();
public:
	__fastcall TProgressDialog(TComponent* AOwner);
	virtual __fastcall ~TProgressDialog();
	static TProgressDialog* __fastcall EnsureCreated();
	virtual void __fastcall Execute();
	virtual void __fastcall Finish();
	virtual void __fastcall ShowParameters(const AnsiString& AProgram, const AnsiString& ADocument);
	virtual void __fastcall ShowInformation(const AnsiString& AMessage);
	virtual void __fastcall ShowWarning(const AnsiString& AMessage);
	virtual void __fastcall ShowError(const AnsiString& AMessage);
	virtual void __fastcall ShowProgress(int ACurrent, int AAll);
	virtual void __fastcall Reset();
	__property TNotifyEvent OnContinue = {read=FOnContinue, write=FOnContinue};
	__property TNotifyEvent OnCancel = {read=FOnCancel, write=FOnCancel};
};
//---------------------------------------------------------------------------
extern PACKAGE TProgressDialog* ProgressDialog;
//---------------------------------------------------------------------------
#endif

